<?php
/** @noinspection PhpUnused */
/** @noinspection PhpMultipleClassDeclarationsInspection */
declare(strict_types=1);

namespace SpaethTech\Tests\ORM\Models;

use DateTime;
use SpaethTech\ORM\Attributes\Column;
use SpaethTech\ORM\Attributes\ExcludeIf;
use SpaethTech\ORM\Attributes\ID;
use SpaethTech\ORM\Attributes\Serializer;
use SpaethTech\ORM\Attributes\Table;
use SpaethTech\ORM\Attributes\Unique;
use SpaethTech\ORM\Methods\DatabaseMethod;
use SpaethTech\ORM\Model;
use SpaethTech\ORM\Serializers\DateTimeSerializer;
use SpaethTech\ORM\Serializers\EnumSerializer;
use SpaethTech\Tests\ORM\Enums\HostStatus;

/**
 * Class ApiHost
 *
 * @author Ryan Spaeth <rspaeth@spaethtech.com>
 * @copyright 2024 Spaeth Technologies Inc.
 *
 * @method int getId()
 * @method string getHost()
 * @method HostStatus getStatus()
 * @method string|null getContinent()
 * @method string|null getCountry()
 * @method string|null getCity()
 * @method string|null getAsn()
 * @method string|null getIsp()
 * @method string|null getNetwork()
 * @method string|null getNickname()
 * @method string|null getNotes()
 * @method DateTime getCreated()
 *
 * @method self setHost(string $Host)
 * @method self setStatus(HostStatus $Status)
 * @method self setContinent(string|null $Continent)
 * @method self setCountry(string|null $Country)
 * @method self setCity(string|null $City)
 * @method self setAsn(string|null $Asn)
 * @method self setIsp(string|null $Isp)
 * @method self setNetwork(string|null $Network)
 * @method self setNickname(string|null $Nickname)
 * @method self setNotes(string|null $Notes)
 * @method self setCreated(DateTime $Created)
 *
 * @generated by Robo 2024-04-17 15:40:08
 *
 * @template-extends Model<self>
 */
#[Table('api_hosts')]
class ApiHost extends Model
{
	#[ID]
	#[Column('id')]
	#[ExcludeIf(DatabaseMethod::INSERT)]
	protected int $Id;

	#[Unique]
	#[Column('host')]
	protected string $Host;

	#[Column('status')]
	#[Serializer(EnumSerializer::class)]
	protected HostStatus $Status;

	#[Column('continent')]
	protected ?string $Continent;

	#[Column('country')]
	protected ?string $Country;

	#[Column('city')]
	protected ?string $City;

	#[Column('asn')]
	protected ?string $Asn;

	#[Column('isp')]
	protected ?string $Isp;

	#[Column('network')]
	protected ?string $Network;

	#[Column('nickname')]
	protected ?string $Nickname;

	#[Column('notes')]
	protected ?string $Notes;

	#[Column('created')]
	#[ExcludeIf(DatabaseMethod::INSERT)]
	#[Serializer(DateTimeSerializer::class)]
	protected DateTime $Created;
}

